deleteVariables("$Surf::Item*");

$ItemTypeColor0 = "B2B2B2"; // Normal (default)
$ItemTypeColor1 = "70B04A"; // Community (donated)
$ItemTypeColor2 = "FFD700"; // Unique (purchaseable)
$ItemTypeColor3 = "8650AC"; // Unusual

$ItemTypePrefix0 = "";
$ItemTypePrefix1 = "Community ";
$ItemTypePrefix2 = "";
$ItemTypePrefix3 = "Unusual ";

function registerSurfItem(%id, %type, %name, %desc, %cost) {
	if ($Surf::ItemCount $= "") {
		$Surf::ItemCount = 0;
	}

	if (!$Surf::ItemExists[%id]) {
		$Surf::Item[$Surf::ItemCount] = %id;
		$Surf::ItemCount++;
	}

	$Surf::ItemName[%id] = %name;
	$Surf::ItemDesc[%id] = %desc;

	$Surf::ItemType[%id] = %type;
	$Surf::ItemCost[%id] = %cost;

	$Surf::ItemExists[%id] = 1;
}

function getSurfItemName(%id, %noColor) {
	if (!$Surf::ItemExists[%id]) {
		echo(%id);
		return "\c5ERROR";
	}

	%name = $Surf::ItemName[%id];
	%type = $Surf::ItemType[%id];

	if ($ItemTypePrefix[%type] !$= "" && getSubStr(%name, 0, 4) $= "The") {
		%name = getSubStr(%name, 4, strLen(%name));
	}

	if (%noColor) {
		return $ItemTypePrefix[%type] @ %name;
	}

	%color = $ItemTypeColor[%type] $= "" ? "\c6" : "<color:" @ $ItemTypeColor[%type] @ ">";
	return %color @ $ItemTypePrefix[%type] @ %name;
}

function getSurfItemID(%name) {
	for (%i = 0; %i < $Surf::ItemCount; %i++) {
		if (%name $= getSurfItemName($Surf::Item[%i], 1)) {
			return $Surf::Item[%i];
		}
	}

	return "";
}

registerSurfItem("trail:default", 0,
	"Blanched Road",
	"Enjoy a debatably sunny day with a debatably colorful trail."
);

registerSurfItem("trail:heart", 1,
	"Fomes Peccati",
	"Filled with Concupiscence. Port loves you."
);

registerSurfItem("trail:laser", 2,
	"Optical Master",
	"26% more clear than the average laser pointer.",
	75
);

registerSurfItem("trail:scorched", 2,
	"Scorched Surface",
	"Whereas most think of a 'scorched sky', this is quite the opposite.",
	100
);

registerSurfItem("trail:dust", 2,
	"Particulate Matter",
	"Prove conspiracies. Prove how dusty the air is by zooming through it.",
	125
);

registerSurfItem("trail:rainbow", 2,
	"Jocund Rainbow",
	"Contains at least 100% more colors than the average surfer. LBGT approved.",
	150
);

registerSurfItem("trail:sparkles", 2,
	"The Twilight Star",
	"Three times the entertainment, not two. Includes 4x Sparkle.",
	200
);

registerSurfItem("trail:acid", 2,
	"Acid Drain",
	"Prove scientists across the world wrong; gravity can be manipulated, and acid can be completely safe. Mostly.",
	200
);

registerSurfItem("trail:global", 3,
	"Sphere of Influence",
	"Show off just how rich you are and how little you pity everyone else.",
	250
);

registerSurfItem("trail:dosh", 2,
	"Lots of Dosh",
	"Literally throw your money out the window. Or onto the track.",
	300
);

registerSurfItem("hat:cap", 2,
	"Confidence Cap",
	"Trusting yourself matters. Even if you're poor.",
	20
);

registerSurfItem("hat:fedora", 2,
	"Fancy Fedora",
	"Neckbeard pride flag. Symbol of professional track making.",
	25
);

registerSurfItem("hat:straw", 2,
	"Federal Straw",
	"Clearing out case studies and southern state criminals all at once.",
	30
);

registerSurfItem("hat:unusual_straw", 3,
	"Federal Straw",
	"Clearing out case studies and southern state criminals all at once.",
	500
);

registerSurfItem("hat:miner", 2,
	"Miner's Headgear",
	"Illuminating the path ahead of you without any light or illumination at all.",
	35
);

registerSurfItem("hat:football", 2,
	"Football Box",
	"Make it clear that you like football (not soccer!) with pride for misleading sport names.",
	40
);

registerSurfItem("hat:german", 2,
	"Prussian Pickelhaube",
	"A relic from one war brought into another. The track will get the point.",
	45
);

registerSurfItem("hat:halo", 2,
	"Halo of Innocence",
	"Not MARBLE MAN approved. Not granted for not idling.",
	75
);

registerSurfItem("hat:tophat", 2,
	"Achromatic Tower",
	"Stay outside the hue spectrum with this non-proportionate top hat.",
	100
);

registerSurfItem("hat:copter", 2,
	"Air Current",
	"Gradually spin while providing no cooling at all. Enlighten animators.",
	150
);

registerSurfItem("hat:headband", 1,
	"Enlightened Athlete",
	"Are you good? Yeah. I am. Look at my headband."
);

function serverCmdShop(%client, %action, %b) {
	if (!isObject(SurfData)) {
		return;
	}

	%user = SurfData.collection("users").document(%client.getBLID());
	%dosh = %user.get("dosh");

	if (%action $= "") {
		%client.chatMessage("\c6You have \c3" @ %dosh @ " dosh\c6.");
		%client.chatMessage(" \c7- \c3/shop list \c6- lists buyable items which you don't already have");
		%client.chatMessage(" \c7- \c3/shop list <category> \c6- lists buyable items of a specific category");
		%client.chatMessage(" \c7- \c3/my items \c6- lists all items which you already have");
		%client.chatMessage(" \c7- \c3/buy <item> \c6- purchases the specific item");
		%client.chatMessage(" \c7- \c3/equip <item> \c6- equips the specific item");
	}
	else if (%action $= "list") {
		%client.chatMessage("\c6Buyable items:");

		for (%i = 0; %i < $Surf::ItemCount; %i++) {
			%id = $Surf::Item[%i];
			%type = $Surf::ItemType[%id];

			if (%type != 0 && %type != 1) {
				%cost = " \c2(" @ $Surf::ItemCost[%id] @ " dosh)";
			}
			else {
				%cost = "";
			}

			%name = getSurfItemName(%id);
			%name = %name SPC "<color:AAAAAA>(" @ getField(strReplace(%id, ":", "\t"), 0);

			if (%client.hasSurfItem(%id)) {
				%name = %name @ ", owned";
			}

			%name = %name @ ")";
			%client.chatMessage("  " @ %name SPC "\c6- " @ $Surf::ItemDesc[%id] @ %cost);
		}

		%client.chatMessage("\c6Use \c5PAGE UP \c6and \c5PAGE DOWN \c6to scroll.");
	}
}

function serverCmdBuy(%client, %a, %b, %c, %d, %e) {
	%item = trim(%a SPC %b SPC %c SPC %d SPC %e);
	%id = getSurfItemID(%item);

	if (!isObject(SurfData)) {
		return;
	}

	if (!$Surf::ItemExists[%id]) {
		%client.chatMessage("\c6Unknown item specified.");
		return;
	}

	%name = getSurfItemName(%id);

	if (%client.hasSurfItem(%id)) {
		%client.chatMessage("\c6You already have " @ %name @ "\c6.");
		return;
	}

	%cost = $Surf::ItemCost[%id];
	%type = $Surf::ItemType[%id];

	if (%type == 0 || %type == 1) {
		%client.chatMessage("\c6You cannot buy a(n) " @ %name @ "\c6.");
		return;
	}

	%user = SurfData.collection("users").document(%client.getBLID());
	%dosh = %user.get("dosh");

	if (%dosh < %cost) {
		%message = '\c6You cannot afford \c3%1 \c6- it costs \c3%2 dosh \c6and you only have \c3%3 dosh\c6.';
		messageClient(%client, '', %message, %name, %cost, %dosh);

		return;
	}

	%user.set("dosh", %dosh - %cost);
	%client.giveSurfItem(%id);

	%message = '\c6You have bought \c3%1 \c6for \c3%2 dosh \c6- you now have \c3%3 dosh\c6.';
	messageClient(%client, '', %message, %name, %cost, %dosh - %cost);
}

function serverCmdMy(%client, %items) {
	if (%items !$= "items" || !isObject(SurfData)) {
		return;
	}

	%items = SurfData.collection("users").document(%client.getBLID()).get("items");

	if (%items $= "") {
		%client.chatMessage("\c6You have no items.");
	}
	else {
		%client.chatMessage("\c6You have the following items:");
		%count = getWordCount(%items);

		for (%i = 0; %i < %count; %i++) {
			%client.chatMessage(" \c7- \c3" @ getSurfItemName(getWord(%items, %i)));
		}

		%client.chatMessage("\c6Use \c5PAGE UP \c6and \c5PAGE DOWN \c6to scroll.");
	}
}

function serverCmdEquip(%client, %a, %b, %c, %d, %e) {
	%item = trim(%a SPC %b SPC %c SPC %d SPC %e);

	if (%item $= "") {
		%client.chatMessage("\c6Equipped items: " @ %user.get("equip"));
		return;
	}

	if (%a $= "no" && %b !$= "" && %c $= "" && %d $= "" && %e $= "") {
		%id = %b @ ":none";
	}
	else {
		%id = getSurfItemID(%item);

		if (!$Surf::ItemExists[%id]) {
			%client.chatMessage("\c6That item doesn't exist.");
			return;
		}

		%uiName = getSurfItemName(%id);

		if (!%client.hasSurfItem(%id)) {
			%client.chatMessage("\c6You do not have a(n) " @ %uiName @ "\c6.");
			return;
		}
	}

	%split = strReplace(%id, ":", "\t");

	%type = getField(%split, 0);
	%name = getField(%split, 1);

	echo(%type SPC %name);

	%user = SurfData.collection("users").document(%client.getBLID());
	%equip = %user.get("equip");

	if (%equip !$= "") {
		%count = getWordCount(%equip);

		for (%i = 0; %i < %count; %i++) {
			%test = getWord(%equip, %i);

			if (getField(strReplace(%test, ":", "\t"), 0) !$= %type) {
				%equip_new = %equip_new @ (%equip_new $= "" ? "" : " ") @ %test;
			}
		}
	}

	if (%name $= "none") {
		%user.set("equip", %equip_new);
		%client.chatMessage("\c6Unequipped" SPC %type SPC "slot.");

		if (isObject(%client.player)) {
			%client.equipSurfItems(%client.player);
		}

		return;
	}

	%user.set("equip", %equip_new @ (%equip_new $= "" ? "" : " ") @ %id);
	%client.chatMessage("\c6Equipped " @ %uiName @ "\c6.");

	if (isObject(%client.player)) {
		%client.equipSurfItems(%client.player);
	}
}

function GameConnection::giveSurfItem(%this, %item) {
	if (!$Surf::ItemExists[%item] || %this.hasSurfItem(%item)) {
		return;
	}

	%user = SurfData.collection("users").document(%this.getBLID());
	%user.set("items", trim(%user.get("items") SPC %item));
}

function GameConnection::hasSurfItem(%this, %item) {
	if (!$Surf::ItemExists[%item]) {
		return 0;
	}

	%user = SurfData.collection("users").document(%this.getBLID());
	return striPos(" " @ %user.get("items") @ " ", " " @ %item @ " ") != -1;
}

function GameConnection::equipSurfItems(%this, %obj) {
	%equip = SurfData.collection("users").document(%this.getBLID()).get("equip");
	%count = getWordCount(%equip);

	for (%i = 0; %i < %count; %i++) {
		%item = getWord(%equip, %i);
		%split = strReplace(%item, ":", "\t");

		%type = getField(%split, 0);
		%name = getField(%split, 1);

		if (%hasEquipped[%type]) {
			continue;
		}

		%hasEquipped[%type] = 1;

		if (%type $= "trail") {
			%obj.mountTrail(nameToID("SurfTrail_" @ %name));
		}
		else if (%type $= "hat") {
			%obj.mountHat(nameToID("SurfHat_" @ %name));
		}
	}
}

function GameConnection::initSurfItems(%this) {
	%user = SurfData.collection("users").document(%this.getBLID());
	%user.setdefault("dosh", 0);

	for (%i = 0; %i < $Surf::ItemCount; %i++) {
		%item = $Surf::Item[%i];

		if ($Surf::ItemType[%item] == 0) {
			%this.giveSurfItem(%item);
		}
	}

	if (!%user.get("equip_initialized")) {
		%user.set("equip_initialized", 1);

		for (%i = 0; %i < $Surf::ItemCount; %i++) {
			%item = $Surf::Item[%i];

			if ($Surf::ItemType[%item] == 0) {
				%type = getField(strReplace(%item, ":", "\t"), 0);

				if (!%hasEquipped[%type]) {
					%equip = %equip @ (%equip $= "" ? "" : " ") @ %item;
					%hasEquipped[%type] = 1;
				}
			}
		}

		%user.set("equip", %equip);
	}
}

function GameConnection::resetSurfItems(%this) {
	%user = SurfData.collection("users").document(%this.getBLID());

	%user.set("items", "");
	%user.set("equip", "");

	%user.set("dosh", "");
	%User.set("equip_initialized", "");

	%this.initSurfItems();
	%this.chatMessage("ALL OF YOUR ITEMS AND DOSH ARE NOW GONE");
}

function Player::mountHat(%this, %image) {
	if (isObject(%image)) {
		%this.mountImage(%image, 1);

		for (%i = 0; %i < $hat[%i] !$= "" ; %i++) {
			%this.hideNode($hat[%i]);
			%this.hideNode($accent[%i]);
		}
	}
	else {
		%this.unmountImage(1);

		if (isObject(%this.client)) {
			%this.client.applyBodyParts();
			%this.client.applyBodyColors();
		}
	}
}

function Player::mountTrail(%this, %image) {
	if (!isObject(%image)) {
		%this.unmountImage(2);
		return;
	}

	%this.mountImage(%image, 2);
}

//////////////////////////////////////////

datablock ParticleData(SurfTrailParticle_Default) {
	textureName = "./blur";

	dragCoefficient = 0;
	gravityCoefficient = 0;
	inheritedVelFactor = 0;
	windCoefficient = 0;

	constantAcceleration = 0;
	useInvAlpha = 0;
	spinSpeed = 0;

	lifetimeMS = 3000;
	lifetimeVarianceMS = 0;

	spinRandomMin = 0;
	spinRandomMax = 0;

	colors[0] = "1 1 1 1";
	colors[1] = "1 1 1 1";
	colors[2] = "1 1 1 1";

	sizes[0] = 0;
	sizes[1] = 0.2;
	sizes[2] = 0;

	times[0] = 0;
	times[1] = 0.5;
	times[2] = 1;
};

datablock ParticleEmitterData(SurfTrailEmitter_Default) {
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;

	ejectionVelocity = 0;
	ejectionOffset = 0;

	velocityVariance = 0;
	overrideAdvance = 0;

	thetaMin = 0;
	thetaMax = 0;

	phiReferenceVel = 0;
	phiVariance = 0;

	particles = SurfTrailParticle_Default;
};

datablock ParticleData(SurfTrailParticle_Laser : SurfTrailParticle_Default) {
	textureName = "./blur";
	lifetimeMS = 2000;

	colors[0] = "1 0 0 1";
	colors[1] = "1 0 0 1";
	colors[2] = "1 0 0 1";

	sizes[0] = 0.1;
	sizes[1] = 0.05;
	sizes[2] = 0;

	times[0] = 0;
	times[1] = 0.5;
	times[2] = 1;
};

datablock ParticleEmitterData(SurfTrailEmitter_Laser : SurfTrailEmitter_Default) {
	ejectionPeriodMS = 5;
	particles = SurfTrailParticle_Laser;
};

datablock ParticleData(SurfTrailParticle_Dust : SurfTrailParticle_Default) {
	textureName = "base/data/particles/cloud";
	useInvAlpha = 1;

	lifetimeMS = 2000;

	colors[0] = "1 1 1 0";
	colors[1] = "0.46 0.46 0.46 0.08";
	colors[2] = "0.8 0.8 1 0";

	//sizes[0] = 0.399805;
	sizes[0] = 1.5;
	//sizes[1] = 0.399805;
	sizes[1] = 1.5;
	//sizes[2] = 1.49545;
	sizes[2] = 4;

	times[0] = 0;
	times[1] = 0.298039;
	times[2] = 1;

	dragCoefficient = 3;
	spinSpeed = 500;

	spinRandomMax = 150;
	spinRandomMin = -150;
};

datablock ParticleEmitterData(SurfTrailEmitter_Dust : SurfTrailEmitter_Default) {
	ejectionPeriodMS = 14;
	ejectionVelocity = 2;
	ejectionOffset = 0.75;
	velocityVariance = 0.1;
	orientOnVelocity = 1;

	thetaMin = 0;
	thetaMax = 360;

	particles = SurfTrailParticle_Dust;
};

datablock ParticleData(SurfTrailParticle_Scorched : SurfTrailParticle_Default) {
	textureName = "base/data/shapes/white";
	lifetimeMS = 3000;

	colors[0] = "1 0.9 0.1 1";
	colors[1] = "1 0.4 0.1 1";
	colors[2] = "1 0.1 0.1 1";

	sizes[0] = 0.01;
	sizes[1] = 0.1;
	sizes[2] = 0;

	times[0] = 0;
	times[1] = 0.05;
	times[2] = 1;
};

datablock ParticleEmitterData(SurfTrailEmitter_Scorched : SurfTrailEmitter_Default) {
	ejectionPeriodMS = 2;
	ejectionOffset = 0.05;

	thetaMin = 0;
	thetaMax = 180;

	phiVariance = 360;
	particles = SurfTrailParticle_Scorched;
};

datablock ParticleData(SurfTrailParticle_Rainbow : SurfTrailParticle_Default) {
	colors[0] = "1 0 0 1";
	colors[1] = "0 1 0 1";
	colors[2] = "0 0 1 1";
};

datablock ParticleEmitterData(SurfTrailEmitter_Rainbow : SurfTrailEmitter_Default) {
	particles = SurfTrailParticle_Rainbow;
};

datablock ParticleData(SurfTrailParticle_Sparkles : SurfTrailParticle_Default) {
	textureName = "base/data/particles/star1";
 
	constantAcceleration = 0;
	useInvAlpha = 1;
	spinSpeed = 100;
 
	spinRandomMin = -50;
	spinRandomMax = 50;
 
	colors[0] = "1 0 1 1";
	colors[1] = "1 0.5 1 1";
	colors[2] = "1 1 1 0";
 
	sizes[0] = 0;
	sizes[1] = 0.2;
	sizes[2] = 0;
 
	times[0] = 0;
	times[1] = 0.25;
	times[2] = 1;
};
 
datablock ParticleEmitterData(SurfTrailEmitter_Sparkles : SurfTrailEmitter_Default) {
	ejectionPeriodMS = 10;
 	ejectionOffset = 0.3;
 
	thetaMin = 0;
	thetaMax = 180;
 
	velocityVariance = 0.15;
 
	phiReferenceVel = 0;
	phiVariance = 360;
 
	particles = SurfTrailParticle_Sparkles;
};

datablock ParticleData(SurfTrailParticle_Acid : SurfTrailParticle_Default) {
	textureName = "Base/Data/Particles/ring";
 
	constantAcceleration = 0.1;
	useInvAlpha = 0;
	spinSpeed = 0;
 
	gravityCoefficient = -0.05;
 
	spinRandomMin = 0;
	spinRandomMax = 0;
 
	colors[0] = "0 0.7 0 1";
	colors[1] = "0 0.7 0 1";
	colors[2] = "0 0.1 0 0";
 
	sizes[0] = 0;
	sizes[1] = 0.2;
	sizes[2] = 0.3;
 
	times[0] = 0;
	times[1] = 0.25;
	times[2] = 1;
};
 
datablock ParticleEmitterData(SurfTrailEmitter_Acid : SurfTrailEmitter_Default) {
	ejectionPeriodMS = 10;
 	ejectionOffset = 0.3;
 
	thetaMin = 0;
	thetaMax = 179;
 
	velocityVariance = 0.2;
 
	phiReferenceVel = 0;
	phiVariance = 360;
 
	particles = SurfTrailParticle_Acid;
};

datablock ParticleData(SurfTrailParticle_Global : SurfTrailParticle_Default) {
	//textureName = "base/data/particles/star1";
	textureName = "./blur";
	lifetimeMS = 3000;
	useInvAlpha = 0;

	colors[0] = "1 0.2 0.1 1";
	colors[1] = "0.15 1 0.15 1";
	colors[2] = "0.1 0.2 1 1";
	colors[3] = "0.15 1 0.15 1";

	sizes[0] = 0.1;
	sizes[1] = 0.3;
	sizes[2] = 0.1;
	sizes[3] = 0;

	times[0] = 0;
	times[1] = 0.33;
	times[2] = 0.66;
	times[3] = 1;
};

datablock ParticleEmitterData(SurfTrailEmitter_Global : SurfTrailEmitter_Default) {
	ejectionPeriodMS = 2;
	ejectionVelocity = 0;
	ejectionOffset = 0.75;

	thetaMin = 0;
	thetaMax = 180;

	phiReferenceVel = 45;
	phiVariance = 0;

	particles = SurfTrailParticle_Global;
};

datablock ParticleData(SurfTrailParticle_Dosh : SurfTrailParticle_Default) {
	textureName = "./dosh";
 
	dragCoefficient = 0.5;
	gravityCoefficient = 0.1;
	inheritedVelFactor = 0.3;
	windCoefficient = 0.6;
 
	constantAcceleration = 0;
	useInvAlpha = 1;
	spinSpeed = 0;
 
	lifetimeMS = 3000;
	lifetimeVarianceMS = 500;
 
	spinRandomMin = -10;
	spinRandomMax = 10;
 
	colors[0] = "1 1 1 1";
	colors[1] = "1 1 1 0.3";
	colors[2] = "1 1 1 0";
 
	sizes[0] = 0.6;
	sizes[1] = 0.6;
	sizes[2] = 0.6;

	times[0] = 0;
	times[1] = 0.75;
	times[2] = 1;
};
 
datablock ParticleEmitterData(SurfTrailEmitter_Dosh : SurfTrailEmitter_Default) {
	ejectionPeriodMS = 50;
	periodVarianceMS = 100;
 
	ejectionVelocity = 0;
	ejectionOffset = 0;
 
	velocityVariance = 2;
	overrideAdvance = 0;
 
	thetaMin = 0;
	thetaMax = 90;
 
	phiReferenceVel = 0;
	phiVariance = 360;

	particles = SurfTrailParticle_Dosh;
};

datablock ParticleData(SurfTrailParticle_Heart : SurfTrailParticle_Default) {
	textureName = "base/data/particles/heart";

	colors[0] = "1 0 0 1";
	colors[1] = "0 1 0 1";
	colors[2] = "0 0 1 0";

	sizes[0] = 0.25;
	sizes[1] = 0.75;
	sizes[2] = 0;
};

datablock ParticleEmitterData(SurfTrailEmitter_Heart : SurfTrailEmitter_Default) {
	ejectionPeriodMS = 25;
	particles = SurfTrailParticle_Heart;
};

//////////////////////////////////////////

datablock ShapeBaseImageData(SurfTrail_Default) {
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = 8;
	offset = "0 0 0.3";

	stateName[0] = "Emit";
	stateEmitter[0] = SurfTrailEmitter_Default;
	stateEmitterTime[0] = 10;
	stateWaitForTimeout[0] = 1;
	stateTransitionOnTimeout[0] = "Loop";

	stateName[1] = "Loop";
	stateTimeoutValue[1] = 0.001;
	stateTransitionOnTimeout[1] = "Emit";
};

datablock ShapeBaseImageData(SurfTrail_Laser : SurfTrail_Default) {
	stateEmitter[0] = SurfTrailEmitter_Laser;
	offset = "0 0 0.3";
};

datablock ShapeBaseImageData(SurfTrail_Dust : SurfTrail_Default) {
	stateEmitter[0] = SurfTrailEmitter_Dust;
	offset = "0 0 1.6";
};

datablock ShapeBaseImageData(SurfTrail_Scorched : SurfTrail_Default) {
	stateEmitter[0] = SurfTrailEmitter_Scorched;
	offset = "0 0 0.3";
};

datablock ShapeBaseImageData(SurfTrail_Rainbow : SurfTrail_Default) {
	stateEmitter[0] = SurfTrailEmitter_Rainbow;
	offset = "0 0 0.3";
};

datablock ShapeBaseImageData(SurfTrail_Sparkles : SurfTrail_Default) {
	stateEmitter[0] = SurfTrailEmitter_Sparkles;
};

datablock ShapeBaseImageData(SurfTrail_Acid : SurfTrail_Default) {
	stateEmitter[0] = SurfTrailEmitter_Acid;
};

datablock ShapeBaseImageData(SurfTrail_Global : SurfTrail_Default) {
	stateEmitter[0] = SurfTrailEmitter_Global;
	offset = "0 -1.5 1.5";
};

datablock ShapeBaseImageData(SurfTrail_Dosh : SurfTrail_Default) {
	stateEmitter[0] = SurfTrailEmitter_Dosh;
	offset = "0 0 0.3";
};

datablock ShapeBaseImageData(SurfTrail_Heart : SurfTrail_Default) {
	stateEmitter[0] = SurfTrailEmitter_Heart;
	offset = "0 0 0.3";
};

//////////////////////////////////////////

datablock ShapeBaseImageData(SurfHat_TopHat) {
	shapeFile = "./shapes/tophat.dts";
	emap = 1;
	mountPoint = 5;

	offset = "0 0.02 0.3";
	eyeOffset = "0 0 0.4";

	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
};

datablock ShapeBaseImageData(SurfHat_Straw) {
	shapeFile = "./SHAPES/Straw3.dts";
	emap = 1;
	mountPoint = 5;

	offset = "0 0.02 0.3";
	eyeOffset = "0 0 0.4";

	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
};

datablock ShapeBaseImageData(SurfHat_Unusual_Straw) {
	shapeFile = "./SHAPES/Straw3.dts";
	emap = 1;
	mountPoint = 5;

	offset = "0 0.02 0.3";
	eyeOffset = "0 0 0.4";

	rotation = eulerToMatrix("0 0 0");
	scale = "1 1 1";

	stateName[0] = "Emit";
	stateEmitter[0] = PlayerTeleportEmitterB;
	stateEmitterTime[0] = 10;
	stateWaitForTimeout[0] = 1;
	stateTransitionOnTimeout[0] = "Loop";

	stateName[1] = "Loop";
	stateTimeoutValue[1] = 0.001;
	stateTransitionOnTimeout[1] = "Emit";
};

datablock ShapeBaseImageData(SurfHat_Miner) {
	shapeFile = "./SHAPES/Miner.dts";
	emap = 1;
	mountPoint = 5;

	offset = "0 0.02 0.3";
	eyeOffset = "0 0 0.4";

	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
};

datablock ShapeBaseImageData(SurfHat_Headband) {
	shapeFile = "./SHAPES/Headband.dts";
	emap = 1;
	mountPoint = 5;

	offset = "0 0.02 0.3";
	eyeOffset = "0 0 0.4";

	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
};

datablock ShapeBaseImageData(SurfHat_Halo) {
	shapeFile = "./SHAPES/Halo.dts";
	emap = 1;
	mountPoint = 5;

	offset = "0 0.02 0.3";
	eyeOffset = "0 0 0.4";

	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
};

datablock ShapeBaseImageData(SurfHat_German) {
	shapeFile = "./SHAPES/German.dts";
	emap = 1;
	mountPoint = 5;

	offset = "0 0.02 0.3";
	eyeOffset = "0 0 0.4";

	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
};

datablock ShapeBaseImageData(SurfHat_Football) {
	shapeFile = "./SHAPES/FootBall.dts";
	emap = 1;
	mountPoint = 5;

	offset = "0 0.02 0.3";
	eyeOffset = "2 2 6 1";

	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
};

datablock ShapeBaseImageData(SurfHat_Fedora) {
	shapeFile = "./SHAPES/Fedora2.dts";
	emap = 1;
	mountPoint = 5;

	offset = "0 0.02 0.3";
	eyeOffset = "0 0 0.4";

	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
};

datablock ShapeBaseImageData(SurfHat_Copter) {
	shapeFile = "./SHAPES/Copter2.dts";
	emap = 1;
	mountPoint = 5;

	offset = "0 0.02 0.3";
	eyeOffset = "0 0 0.4";

	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
};

datablock ShapeBaseImageData(SurfHat_Cap) {
	shapeFile = "./SHAPES/Cap.dts";
	emap = 1;
	mountPoint = 5;

	offset = "0 0.02 0.3";
	eyeOffset = "0 0 0.4";

	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
};